"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
function EventObj(name) {
  this.name = name;
  this.callbacks = [];

  this.registerCallback = function registerCallback(callback) {
    this.callbacks.push(callback);
  };

  this.removeCallbacks = function removeCallbacks() {
    this.callbacks.clear();
  };
}

exports.default = EventObj;