"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Range = function () {
  function Range(from, to) {
    _classCallCheck(this, Range);

    this.from = from;
    this.to = to;
  }

  _createClass(Range, [{
    key: "apply",
    value: function apply(value) {
      if (this.from >= value) return this.from;
      if (this.to <= value) return this.to;
      return value;
    }
  }, {
    key: "isIn",
    value: function isIn(value) {
      var include = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      return !(include && !(this.from <= value && this.to >= value)) && !(!include && !(this.from < value && this.to > value));
    }
  }, {
    key: "generateNumber",
    value: function generateNumber() {
      return Math.random() * (this.to - this.from) + this.from;
    }
  }]);

  return Range;
}();

Range.ZeroToOne = new Range(0, 1);
Range.MinusOneToOne = new Range(-1, 1);

exports.default = Range;